Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/concvl.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/concvl.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/concvl.F90	(revision 4727)
@@ -3,5 +3,5 @@
                   t, q, t_wake, q_wake, s_wake, u, v, tra, ntra, &
                   Ale, Alp, sig1, w01, &
-                  d_t, d_q, d_u, d_v, d_tra, &
+                  d_t, d_q, d_qcomp, d_u, d_v, d_tra, &
                   rain, snow, kbas, ktop, sigd, &
                   cbmf, plcl, plfc, wbeff, convoccur, &
@@ -16,5 +16,5 @@
                   dd_t, dd_q, lalim_conv, wght_th, &                 ! RomP
                   evap, ep, epmlmMm, eplaMm, &                       ! RomP
-                  wdtrainA, wdtrainS, wdtrainM, wght, qtc, sigt, &
+                  wdtrainA, wdtrainS, wdtrainM, wght, qtc, sigt, detrain, &
                   tau_cld_cv, coefw_cld_cv, &                           ! RomP+RL, AJ
 !RomP <<<
@@ -105,5 +105,5 @@
   REAL, DIMENSION(klon,klev),   INTENT(INOUT)   :: sig1, w01
 
-  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: d_t, d_q, d_u, d_v
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: d_t, d_q, d_qcomp, d_u, d_v
   REAL, DIMENSION(klon,klev, nbtr),INTENT(OUT)  :: d_tra
   REAL, DIMENSION(klon),        INTENT(OUT)     :: rain, snow
@@ -145,5 +145,5 @@
   REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: wght                       !RL
   REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: qtc
-  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: sigt
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: sigt, detrain
   REAL,                         INTENT(OUT)     :: tau_cld_cv, coefw_cld_cv
   REAL, DIMENSION(klon),        INTENT(OUT)     :: epmax_diag                ! epmax_cape
@@ -429,5 +429,5 @@
                     Ale, Alp, omega, &
                     em_sig1feed, em_sig2feed, em_wght, &
-                    iflag, d_t, d_q, d_u, d_v, d_tra, rain, kbas, ktop, &
+                    iflag, d_t, d_q, d_qcomp, d_u, d_v, d_tra, rain, kbas, ktop, &
                     cbmf, plcl, plfc, wbeff, sig1, w01, ptop2, sigd, &
                     Ma, mip, Vprecip, Vprecipi, upwd, dnwd, dnwdbis, qcondc, wd, &
@@ -440,5 +440,5 @@
                     da, phi, mp, phii, d1a, dam, sij, wght, &           ! RomP+RL
                     qta, clw, elij, evap, ep, epmlmMm, eplaMm, &        ! RomP+RL
-                    wdtrainA, wdtrainS, wdtrainM, qtc, sigt, &
+                    wdtrainA, wdtrainS, wdtrainM, qtc, sigt, detrain, &
                     tau_cld_cv, coefw_cld_cv, &                         ! RomP,AJ
 !AC!+!RomP+jyg
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/conf_phys_m.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/conf_phys_m.F90	(revision 4727)
@@ -16,5 +16,5 @@
        fact_cldcon, facttemps,ok_newmicro,iflag_radia,&
        iflag_cld_th, &
-       iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
+       ratqsbas,ratqshaut,tau_ratqs, &
        ok_ade, ok_aie, ok_alw, ok_cdnc, ok_volcan, flag_volc_surfstrat, aerosol_couple, & 
        chemistry_couple, flag_aerosol, flag_aerosol_strat, flag_aer_feedback, &
@@ -29,11 +29,12 @@
     USE carbon_cycle_mod,  ONLY: read_fco2_ocean_cor,var_fco2_ocean_cor
     USE carbon_cycle_mod,  ONLY: read_fco2_land_cor,var_fco2_land_cor
+    USE chemistry_cycle_mod, ONLY: dms_cycle_cpl
     USE mod_grid_phy_lmdz, ONLY: klon_glo
     USE print_control_mod, ONLY: lunout
     use config_ocean_skin_m, only: config_ocean_skin
     USE phys_state_var_mod, ONLY: phys_tstep
+    USE infotrac_phy, ONLY: type_trac
 
     INCLUDE "conema3.h"
-    INCLUDE "fisrtilp.h"
     INCLUDE "nuage.h"
     INCLUDE "YOMCST.h"
@@ -86,5 +87,5 @@
     REAL                 :: fact_cldcon, facttemps,ratqsbas,ratqshaut,tau_ratqs
     INTEGER              :: iflag_cld_th
-    INTEGER              :: iflag_ratqs
+     
 
     CHARACTER (len = 6), SAVE  :: type_ocean_omp, version_ocean_omp, ocean_omp
@@ -171,20 +172,8 @@
     LOGICAL,SAVE :: ok_adj_ema_omp
     INTEGER,SAVE :: iflag_clw_omp
-    REAL,SAVE :: cld_lc_lsc_omp,cld_lc_con_omp,cld_tau_lsc_omp,cld_tau_con_omp
-    REAL,SAVE :: ffallv_lsc_omp, ffallv_con_omp,coef_eva_omp,coef_eva_i_omp
-    LOGICAL,SAVE :: reevap_ice_omp
-    INTEGER,SAVE :: iflag_pdf_omp
     INTEGER,SAVE :: iflag_ice_thermo_omp
     LOGICAL,SAVE :: ok_ice_sursat_omp
     LOGICAL,SAVE :: ok_plane_h2o_omp, ok_plane_contrail_omp
-    INTEGER,SAVE :: iflag_t_glace_omp
-    INTEGER,SAVE :: iflag_cloudth_vert_omp
-    INTEGER,SAVE :: iflag_rain_incloud_vol_omp
-    INTEGER,SAVE :: iflag_vice_omp, iflag_rei_omp
     REAL,SAVE :: rad_froid_omp, rad_chau1_omp, rad_chau2_omp
-    REAL,SAVE :: t_glace_min_omp, t_glace_max_omp
-    REAL,SAVE :: exposant_glace_omp
-    INTEGER,SAVE :: iflag_gammasat_omp
-    REAL,SAVE :: rei_min_omp, rei_max_omp
     INTEGER,SAVE :: iflag_sic_omp, iflag_inertie_omp
     REAL,SAVE :: inertie_sol_omp,inertie_sno_omp,inertie_sic_omp
@@ -200,5 +189,5 @@
     REAL, SAVE ::  fmagic_omp, pmagic_omp
     INTEGER,SAVE :: iflag_pbl_omp,lev_histhf_omp,lev_histday_omp,lev_histmth_omp
-    INTEGER,SAVE :: iflag_pbl_split_omp
+    INTEGER,SAVE :: iflag_pbl_split_omp,iflag_physiq_omp
 !FC
     INTEGER,SAVE :: ifl_pbltree_omp
@@ -234,6 +223,4 @@
     INTEGER, SAVE :: iflag_ener_conserv_omp
     LOGICAL, SAVE :: ok_conserv_q_omp
-    INTEGER, SAVE :: iflag_fisrtilp_qsat_omp
-    INTEGER, SAVE :: iflag_bergeron_omp
     LOGICAL,SAVE  :: ok_strato_omp
     LOGICAL,SAVE  :: ok_hines_omp, ok_gwd_rando_omp
@@ -246,4 +233,5 @@
     LOGICAL, SAVE :: carbon_cycle_cpl_omp
     LOGICAL, SAVE :: carbon_cycle_rad_omp
+    LOGICAL, SAVE :: dms_cycle_cpl_omp
     INTEGER, SAVE :: level_coupling_esm_omp
     LOGICAL, SAVE :: read_fco2_ocean_cor_omp
@@ -255,4 +243,9 @@
     LOGICAL, SAVE :: ok_new_lscp_omp
     LOGICAL, SAVE :: ok_icefra_lscp_omp
+    !rajout de choix_bulk et nit_bulk par Olivier Torres
+    INTEGER,SAVE  :: choix_bulk_omp
+    INTEGER,SAVE  :: nit_bulk_omp
+    INTEGER,SAVE  :: kz0_omp
+    LOGICAL, SAVE :: ok_bs_omp, ok_rad_bs_omp
 
 
@@ -948,4 +941,31 @@
     CALL getin('nbapp_rad',nbapp_rad_omp)
 
+    !rajout Olivier Torres
+    !Config  Key  = choix_bulk
+    !Config  Desc = choix de la formulation bulk a prendre dans clcdrag au-dessus de l'ocean
+    !Config  Def  = 0
+    !Config         0 -> originale (lmdz/Louis 79)
+    !Config         1 -> COARE
+    !Config         2 -> CORE-"pure" (cf. Large)
+    !Config         3 -> CORE-"mixte" (avec z_0 et C_T^N donnees par Smith 88)
+    choix_bulk_omp = 0
+    CALL getin('choix_bulk',choix_bulk_omp)
+
+    !Config  Key  = nit_bulk
+    !Config  Desc = choix du nombre d'it de pt fixe dans la bulk
+    !Config  Def  = 5
+    nit_bulk_omp = 1
+    CALL getin('nit_bulk',nit_bulk_omp)
+
+    !Config  Key  = kz0
+    !Config  Desc = choix de la formulation z0 pour la bulk ECUME
+    !Config  Def  = 1
+    !Config         0 -> ARPEGE formulation
+    !Config         1 -> Smith Formulation
+    !Config         2 -> Direct computation using the stability functions
+    kz0_omp = 0
+    CALL getin('kz0',kz0_omp)
+
+
     !Config  Key  = iflag_con
     !Config  Desc = Flag de convection
@@ -992,21 +1012,4 @@
     CALL getin('ok_conserv_q',ok_conserv_q_omp)
 
-    !Config  Key  = iflag_fisrtilp_qsat
-    !Config  Desc = Flag de fisrtilp
-    !Config  Def  = 0
-    !Config  Help = Flag  pour la pluie grande-échelle les options suivantes existent :
-    !Config         >1 nb iterations pour converger dans le calcul de qsat
-    iflag_fisrtilp_qsat_omp = 0
-    CALL getin('iflag_fisrtilp_qsat',iflag_fisrtilp_qsat_omp)
-
-    !Config  Key  = iflag_bergeron
-    !Config  Desc = Flag de fisrtilp
-    !Config  Def  = 0
-    !Config  Help = Flag  pour la pluie grande-échelle les options suivantes existent :
-    !Config         0 pas d effet Bergeron
-    !Config         1 effet Bergeron pour T<0
-    iflag_bergeron_omp = 0
-    CALL getin('iflag_bergeron',iflag_bergeron_omp)
-
     !
     !
@@ -1067,76 +1070,5 @@
     iflag_clw_omp = 0
     CALL getin('iflag_clw',iflag_clw_omp)
-    !
-    !Config Key  = cld_lc_lsc 
-    !Config Desc =  
-    !Config Def  = 2.6e-4
-    !Config Help = 
-    !
-    cld_lc_lsc_omp = 2.6e-4
-    CALL getin('cld_lc_lsc',cld_lc_lsc_omp)
-    !
-    !Config Key  = cld_lc_con
-    !Config Desc =  
-    !Config Def  = 2.6e-4
-    !Config Help = 
-    !
-    cld_lc_con_omp = 2.6e-4
-    CALL getin('cld_lc_con',cld_lc_con_omp)
-    !
-    !Config Key  = cld_tau_lsc
-    !Config Desc =  
-    !Config Def  = 3600.
-    !Config Help = 
-    !
-    cld_tau_lsc_omp = 3600.
-    CALL getin('cld_tau_lsc',cld_tau_lsc_omp)
-    !
-    !Config Key  = cld_tau_con
-    !Config Desc =  
-    !Config Def  = 3600.
-    !Config Help = 
-    !
-    cld_tau_con_omp = 3600.
-    CALL getin('cld_tau_con',cld_tau_con_omp)
-    !
-    !Config Key  = ffallv_lsc
-    !Config Desc =  
-    !Config Def  = 1.
-    !Config Help = 
-    !
-    ffallv_lsc_omp = 1.
-    CALL getin('ffallv_lsc',ffallv_lsc_omp)
-    !
-    !Config Key  = ffallv_con
-    !Config Desc =  
-    !Config Def  = 1.
-    !Config Help = 
-    !
-    ffallv_con_omp = 1.
-    CALL getin('ffallv_con',ffallv_con_omp)
-    !
-    !Config Key  = coef_eva
-    !Config Desc =  
-    !Config Def  = 2.e-5
-    !Config Help = 
-    !
-    coef_eva_omp = 2.e-5
-    CALL getin('coef_eva',coef_eva_omp)
-    !
-    !Config Key  = coef_eva_i
-    !Config Desc =  
-    !Config Def  = 2.e-5
-    !Config Help = 
-    !
-    coef_eva_i_omp = coef_eva_omp
-    CALL getin('coef_eva_i',coef_eva_i_omp)
-    !
-    !Config Key  = reevap_ice
-    !Config Desc =  
-    !Config Def  = .FALSE.
-    !Config Help = 
-    !
-    reevap_ice_omp = .FALSE.
-    CALL getin('reevap_ice',reevap_ice_omp)
+    
 
     !Config Key  = iflag_ratqs
@@ -1254,12 +1186,4 @@
 
     !
-    !Config Key  = iflag_pdf 
-    !Config Desc =  
-    !Config Def  = 0
-    !Config Help = 
-    !
-    iflag_pdf_omp = 0
-    CALL getin('iflag_pdf',iflag_pdf_omp)
-    !
     !Config Key  = fact_cldcon
     !Config Desc =  
@@ -1412,85 +1336,4 @@
     CALL getin('rad_chau2',rad_chau2_omp)
 
-    !
-    !Config Key  = t_glace_min
-    !Config Desc =  
-    !Config Def  = 258.
-    !Config Help = 
-    !
-    t_glace_min_omp = 258.
-    CALL getin('t_glace_min',t_glace_min_omp)
-
-    !
-    !Config Key  = t_glace_max
-    !Config Desc =  
-    !Config Def  = 273.13
-    !Config Help = 
-    !
-    t_glace_max_omp = 273.13
-    CALL getin('t_glace_max',t_glace_max_omp)
-
-    !
-    !Config Key  = exposant_glace
-    !Config Desc =  
-    !Config Def  = 2.
-    !Config Help = 
-    !
-    exposant_glace_omp = 1.
-    CALL getin('exposant_glace',exposant_glace_omp)
-
-    !
-    !Config Key  = iflag_gammasat
-    !Config Desc =  
-    !Config Def  = 0
-    !Config Help = 
-    !
-    iflag_gammasat_omp=0
-    CALL getin('iflag_gammasat',iflag_gammasat_omp)
-
-
-    !
-    !Config Key  = iflag_t_glace
-    !Config Desc =  
-    !Config Def  = 0
-    !Config Help = 
-    !
-    iflag_t_glace_omp = 0
-    CALL getin('iflag_t_glace',iflag_t_glace_omp)
-
-    !
-    !Config Key  = iflag_cloudth_vert
-    !Config Desc =  
-    !Config Def  = 0
-    !Config Help = 
-    !
-    iflag_cloudth_vert_omp = 0
-    CALL getin('iflag_cloudth_vert',iflag_cloudth_vert_omp)
-
-    !
-    !Config Key  = iflag_rain_incloud_vol
-    !Config Desc =  
-    !Config Def  = 0
-    !Config Help = 
-    !
-    iflag_rain_incloud_vol_omp = 0
-    CALL getin('iflag_rain_incloud_vol',iflag_rain_incloud_vol_omp)
-
-    !
-    !Config Key  = iflag_vice
-    !Config Desc =  
-    !Config Def  = 0
-    !Config Help = 
-    !
-    iflag_vice_omp = 0
-    CALL getin('iflag_vice',iflag_vice_omp)
-
-    !Config Key  = iflag_rei
-    !Config Desc =  
-    !Config Def  = 0
-    !Config Help = 
-    !
-    iflag_rei_omp = 0
-    CALL getin('iflag_rei',iflag_rei_omp)
-
 
     !
@@ -1527,22 +1370,4 @@
     ok_plane_contrail_omp = .FALSE.
     CALL getin('ok_plane_contrail',ok_plane_contrail_omp)
-
-    !
-    !Config Key  = rei_min
-    !Config Desc =  
-    !Config Def  = 3.5
-    !Config Help = 
-    !
-    rei_min_omp = 3.5
-    CALL getin('rei_min',rei_min_omp)
-
-    !
-    !Config Key  = rei_max
-    !Config Desc =  
-    !Config Def  = 61.29
-    !Config Help = 
-    !
-    rei_max_omp = 61.29
-    CALL getin('rei_max',rei_max_omp)
 
     !
@@ -1664,4 +1489,7 @@
     CALL getin('iflag_pbl',iflag_pbl_omp)
 
+    iflag_physiq_omp = 0 ! 0: std, 1: with physiqex output, 2: for physiqex
+    CALL getin('iflag_physiq',iflag_physiq_omp)
+
 !FC
     !Config Key  = ifl_pbltree
@@ -1713,10 +1541,9 @@
     nsplit_thermals_omp = 1
     CALL getin('nsplit_thermals',nsplit_thermals_omp)
-
-    !Config Key  = alp_bl_k
-    !Config Desc =
-    !Config Def  = 0.
-    !Config Help =
-    !
+    !
+    !Config Key  = nsplit_thermals
+    !Config Desc =
+    !Config Def  = 0
+    !Config Help =
     alp_bl_k_omp = 1.
     CALL getin('alp_bl_k',alp_bl_k_omp)
@@ -2359,4 +2186,22 @@
     !Config Help = ...
 
+
+
+    ok_bs_omp = .FALSE.
+    CALL getin('ok_bs', ok_bs_omp)
+    !
+    !Config Key  = ok_bs_omp
+    !Config Desc = include blowing snow
+    !Config Def  = .FALSE.
+    !Config Help = ...
+
+
+    ok_rad_bs_omp = .FALSE.
+    CALL getin('ok_rad_bs', ok_rad_bs_omp)
+    !
+    !Config Key  = ok_rad_bs_omp
+    !Config Desc = include blowing snow radiative effect
+    !Config Def  = .FALSE.
+    !Config Help = ...
 
     ecrit_LES_omp = 1./8.
@@ -2400,4 +2245,14 @@
     CALL getin('level_coupling_esm',level_coupling_esm_omp)
 
+
+    dms_cycle_cpl_omp=.FALSE.
+    CALL getin('transm_dms_oa',dms_cycle_cpl_omp)
+    !
+    !Config Key  = dms_cycle_cpl
+    !Config Desc = receive dms from pisces via oasis
+    !Config Def  = .FALSE.
+    !Config Help = can be activated only if lmdz use inca for the atmospheric chemistry 
+
+    
     !$OMP END MASTER
     !$OMP BARRIER
@@ -2446,21 +2301,8 @@
     iflag_ener_conserv = iflag_ener_conserv_omp
     ok_conserv_q = ok_conserv_q_omp
-    iflag_fisrtilp_qsat = iflag_fisrtilp_qsat_omp
-    iflag_bergeron = iflag_bergeron_omp
-
     epmax = epmax_omp
     coef_epmax_cape = coef_epmax_cape_omp
     ok_adj_ema = ok_adj_ema_omp
     iflag_clw = iflag_clw_omp
-    cld_lc_lsc = cld_lc_lsc_omp
-    cld_lc_con = cld_lc_con_omp
-    cld_tau_lsc = cld_tau_lsc_omp
-    cld_tau_con = cld_tau_con_omp
-    ffallv_lsc = ffallv_lsc_omp
-    ffallv_con = ffallv_con_omp
-    coef_eva = coef_eva_omp
-    coef_eva_i = coef_eva_i_omp
-    reevap_ice = reevap_ice_omp
-    iflag_pdf = iflag_pdf_omp
     solarlong0 = solarlong0_omp
     qsol0 = qsol0_omp
@@ -2473,22 +2315,13 @@
     inertie_lic = inertie_lic_omp
     inertie_sno = inertie_sno_omp
+    ok_bs = ok_bs_omp
+    ok_rad_bs=ok_rad_bs_omp
     rad_froid = rad_froid_omp
     rad_chau1 = rad_chau1_omp
     rad_chau2 = rad_chau2_omp
-    t_glace_min = t_glace_min_omp
-    t_glace_max = t_glace_max_omp
-    exposant_glace = exposant_glace_omp
-    iflag_gammasat=iflag_gammasat_omp
-    iflag_t_glace = iflag_t_glace_omp
-    iflag_cloudth_vert=iflag_cloudth_vert_omp
-    iflag_rain_incloud_vol=iflag_rain_incloud_vol_omp
-    iflag_vice=iflag_vice_omp
-    iflag_rei=iflag_rei_omp
     iflag_ice_thermo = iflag_ice_thermo_omp
     ok_ice_sursat = ok_ice_sursat_omp
     ok_plane_h2o = ok_plane_h2o_omp
     ok_plane_contrail = ok_plane_contrail_omp
-    rei_min = rei_min_omp
-    rei_max = rei_max_omp
     top_height = top_height_omp
     overlap = overlap_omp
@@ -2502,4 +2335,5 @@
     pmagic = pmagic_omp
     iflag_pbl = iflag_pbl_omp
+    iflag_physiq = iflag_physiq_omp
     iflag_pbl_split = iflag_pbl_split_omp
 !FC
@@ -2692,4 +2526,9 @@
     read_fco2_land_cor = read_fco2_land_cor_omp
     var_fco2_land_cor = var_fco2_land_cor_omp
+    dms_cycle_cpl = dms_cycle_cpl_omp
+    !rajout Olivier Torres
+    kz0=kz0_omp
+    choix_bulk = choix_bulk_omp
+    nit_bulk = nit_bulk_omp
 
     ! Test of coherence between type_ocean and version_ocean
@@ -2811,4 +2650,10 @@
     ENDIF
 
+
+    ! Test on chemistry cycle 
+    IF ((type_trac .ne. "inca" .AND. type_trac .ne. "inco") .AND. dms_cycle_cpl ) THEN 
+       CALL abort_physic('conf_phys', 'dms_cycle_cpl has to be TRUE only with INCA coupling model',1)
+    ENDIF
+    
     ! ORCHIDEE must be activated for ifl_pbltree=1
     IF (.NOT. ok_veget .AND. ifl_pbltree==1) THEN
@@ -2872,20 +2717,8 @@
     WRITE(lunout,*) ' iflag_ener_conserv=',iflag_ener_conserv
     WRITE(lunout,*) ' ok_conserv_q=',ok_conserv_q
-    WRITE(lunout,*) ' iflag_fisrtilp_qsat=',iflag_fisrtilp_qsat
-    WRITE(lunout,*) ' iflag_bergeron=',iflag_bergeron
     WRITE(lunout,*) ' epmax = ', epmax
     WRITE(lunout,*) ' coef_epmax_cape = ', coef_epmax_cape
     WRITE(lunout,*) ' ok_adj_ema = ', ok_adj_ema
     WRITE(lunout,*) ' iflag_clw = ', iflag_clw
-    WRITE(lunout,*) ' cld_lc_lsc = ', cld_lc_lsc
-    WRITE(lunout,*) ' cld_lc_con = ', cld_lc_con
-    WRITE(lunout,*) ' cld_tau_lsc = ', cld_tau_lsc
-    WRITE(lunout,*) ' cld_tau_con = ', cld_tau_con
-    WRITE(lunout,*) ' ffallv_lsc = ', ffallv_lsc
-    WRITE(lunout,*) ' ffallv_con = ', ffallv_con
-    WRITE(lunout,*) ' coef_eva = ', coef_eva
-    WRITE(lunout,*) ' coef_eva_i = ', coef_eva_i
-    WRITE(lunout,*) ' reevap_ice = ', reevap_ice
-    WRITE(lunout,*) ' iflag_pdf = ', iflag_pdf
     WRITE(lunout,*) ' iflag_cld_th = ', iflag_cld_th
     WRITE(lunout,*) ' iflag_cld_cv = ', iflag_cld_cv
@@ -2909,19 +2742,8 @@
     WRITE(lunout,*) ' rad_chau1 = ',rad_chau1
     WRITE(lunout,*) ' rad_chau2 = ',rad_chau2
-    WRITE(lunout,*) ' t_glace_min = ',t_glace_min
-    WRITE(lunout,*) ' t_glace_max = ',t_glace_max
-    WRITE(lunout,*) ' exposant_glace = ',exposant_glace
-    WRITE(lunout,*) ' iflag_gammasat = ',iflag_gammasat
-    WRITE(lunout,*) ' iflag_t_glace = ',iflag_t_glace
-    WRITE(lunout,*) ' iflag_cloudth_vert = ',iflag_cloudth_vert
-    WRITE(lunout,*) ' iflag_rain_incloud_vol = ',iflag_rain_incloud_vol
-    WRITE(lunout,*) ' iflag_vice = ',iflag_vice
-    WRITE(lunout,*) ' iflag_rei = ',iflag_rei
     WRITE(lunout,*) ' iflag_ice_thermo = ',iflag_ice_thermo
     WRITE(lunout,*) ' ok_ice_sursat = ',ok_ice_sursat
     WRITE(lunout,*) ' ok_plane_h2o = ',ok_plane_h2o
     WRITE(lunout,*) ' ok_plane_contrail = ',ok_plane_contrail
-    WRITE(lunout,*) ' rei_min = ',rei_min
-    WRITE(lunout,*) ' rei_max = ',rei_max
     WRITE(lunout,*) ' overlap = ',overlap 
     WRITE(lunout,*) ' cdmmax = ',cdmmax 
@@ -2957,4 +2779,5 @@
     WRITE(lunout,*) ' freq_calNMC = ',freq_calNMC
     WRITE(lunout,*) ' iflag_pbl = ', iflag_pbl
+    WRITE(lunout,*) ' iflag_physiq = ', iflag_physiq
 !FC
     WRITE(lunout,*) ' ifl_pbltree = ', ifl_pbltree
@@ -2982,4 +2805,6 @@
     WRITE(lunout,*) ' inertie_lic = ', inertie_lic
     WRITE(lunout,*) ' inertie_sno = ', inertie_sno
+    WRITE(lunout,*) ' ok_bs = ', ok_bs
+    WRITE(lunout,*) ' ok_rad_bs = ', ok_rad_bs
     WRITE(lunout,*) ' f_cdrag_ter = ',f_cdrag_ter
     WRITE(lunout,*) ' f_cdrag_oce = ',f_cdrag_oce
@@ -3039,4 +2864,5 @@
     WRITE(lunout,*) ' read_fco2_land_cor = ', read_fco2_land_cor
     WRITE(lunout,*) ' var_fco2_land_cor = ', var_fco2_land_cor
+    WRITE(lunout,*) ' dms_cycle_cpl = ', dms_cycle_cpl
     WRITE(lunout,*) ' iflag_tsurf_inlandsis = ', iflag_tsurf_inlandsis
     WRITE(lunout,*) ' iflag_temp_inlandsis = ', iflag_temp_inlandsis
@@ -3056,4 +2882,8 @@
     WRITE(lunout,*) ' buf_sph_pol = ', buf_sph_pol
     WRITE(lunout,*) ' buf_siz_pol= ', buf_siz_pol
+    !rajout Olivier Torres
+    write(lunout,*) 'choix_bulk = ', choix_bulk
+    write(lunout,*) 'nit_bulk = ', nit_bulk
+    write(lunout,*) 'kz0 = ', kz0
 
     !$OMP END MASTER
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp/cosp_output_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp/cosp_output_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp/cosp_output_mod.F90	(revision 4727)
@@ -235,9 +235,6 @@
   USE time_phylmdz_mod, ONLY: day_ref, annee_ref, day_ini, start_time, itau_phy
   USE print_control_mod, ONLY: lunout
-
-#ifdef CPP_XIOS
-    ! ug Pour les sorties XIOS
-    USE wxios
-#endif
+  ! ug Pour les sorties XIOS
+  USE wxios
 
   IMPLICIT NONE
@@ -263,11 +260,9 @@
 !!! Variables d'entree
 
-#ifdef CPP_XIOS
-    ! ug Variables utilisées pour récupérer le calendrier pour xios
-    INTEGER :: x_an, x_mois, x_jour
-    REAL :: x_heure
-    INTEGER :: ini_an, ini_mois, ini_jour
-    REAL :: ini_heure
-#endif
+  ! ug Variables utilisées pour récupérer le calendrier pour xios
+  INTEGER :: x_an, x_mois, x_jour
+  REAL :: x_heure
+  INTEGER :: ini_an, ini_mois, ini_jour
+  REAL :: ini_heure
 
     WRITE(lunout,*) 'Debut cosp_output_mod.F90'
@@ -316,39 +311,39 @@
     CALL ymds2ju(annee_ref, 1, day_ini, start_time, zjulian_start)
 
-#ifdef CPP_XIOS
+    IF (using_xios) THEN
     
-! recuperer la valeur indefine Xios
-!    CALL xios_get_field_attr("clcalipso",default_value=Cosp_fill_value)
-!         Cosp_fill_value=missing_val
-          Cosp_fill_value=0.
-         print*,'Cosp_fill_value=',Cosp_fill_value
-!    if (use_vgrid) then
-!      print*,'vgrid%Nlvgrid, vgrid%z = ',vgrid%Nlvgrid, vgrid%z
-        CALL wxios_add_vaxis("height", vgrid%Nlvgrid, vgrid%z)
-     print*,'wxios_add_vaxis '
-!    else
-!         WRITE(lunout,*) 'wxios_add_vaxis "presnivs", vgrid%Nlvgrid ',vgrid%Nlvgrid
-!        CALL wxios_add_vaxis("presnivs", vgrid%Nlvgrid, presnivs)
-!    endif
-    WRITE(lunout,*) 'wxios_add_vaxis height_mlev, Nlevlmdz ',Nlevlmdz
-    CALL wxios_add_vaxis("height_mlev", Nlevlmdz, vgrid%mz)
-    WRITE(lunout,*) 'wxios_add_vaxis sza, PARASOL_NREFL ',PARASOL_NREFL
-    CALL wxios_add_vaxis("sza", PARASOL_NREFL, PARASOL_SZA)
-    WRITE(lunout,*) 'wxios_add_vaxis pressure2 ',7
-    CALL wxios_add_vaxis("pressure2", 7, ISCCP_PC)
-    WRITE(lunout,*) 'wxios_add_vaxis column ',Ncolumns
-    CALL wxios_add_vaxis("column", Ncolumns, column_ax)
-
-! AI nov 2015
-   CALL wxios_add_vaxis("temp", LIDAR_NTEMP, LIDAR_PHASE_TEMP)
-   CALL wxios_add_vaxis("cth", MISR_N_CTH, MISR_CTH)
-   CALL wxios_add_vaxis("dbze", DBZE_BINS, dbze_ax) 
-   CALL wxios_add_vaxis("scatratio", SR_BINS, sratio_ax)
-   CALL wxios_add_vaxis("ReffIce", numMODISReffIceBins, reffICE_binCenters)
-   CALL wxios_add_vaxis("ReffLiq", numMODISReffLiqBins, reffLIQ_binCenters)
-   print*,'reffICE_binCenters=',reffICE_binCenters
-   CALL wxios_add_vaxis("tau", 7, ISCCP_TAU)
-
-#endif
+  ! recuperer la valeur indefine Xios
+  !    CALL xios_get_field_attr("clcalipso",default_value=Cosp_fill_value)
+  !         Cosp_fill_value=missing_val
+            Cosp_fill_value=0.
+           print*,'Cosp_fill_value=',Cosp_fill_value
+  !    if (use_vgrid) then
+  !      print*,'vgrid%Nlvgrid, vgrid%z = ',vgrid%Nlvgrid, vgrid%z
+          CALL wxios_add_vaxis("height", vgrid%Nlvgrid, vgrid%z)
+       print*,'wxios_add_vaxis '
+  !    else
+  !         WRITE(lunout,*) 'wxios_add_vaxis "presnivs", vgrid%Nlvgrid ',vgrid%Nlvgrid
+  !        CALL wxios_add_vaxis("presnivs", vgrid%Nlvgrid, presnivs)
+  !    endif
+      WRITE(lunout,*) 'wxios_add_vaxis height_mlev, Nlevlmdz ',Nlevlmdz
+      CALL wxios_add_vaxis("height_mlev", Nlevlmdz, vgrid%mz)
+      WRITE(lunout,*) 'wxios_add_vaxis sza, PARASOL_NREFL ',PARASOL_NREFL
+      CALL wxios_add_vaxis("sza", PARASOL_NREFL, PARASOL_SZA)
+      WRITE(lunout,*) 'wxios_add_vaxis pressure2 ',7
+      CALL wxios_add_vaxis("pressure2", 7, ISCCP_PC)
+      WRITE(lunout,*) 'wxios_add_vaxis column ',Ncolumns
+      CALL wxios_add_vaxis("column", Ncolumns, column_ax)
+
+  ! AI nov 2015
+     CALL wxios_add_vaxis("temp", LIDAR_NTEMP, LIDAR_PHASE_TEMP)
+     CALL wxios_add_vaxis("cth", MISR_N_CTH, MISR_CTH)
+     CALL wxios_add_vaxis("dbze", DBZE_BINS, dbze_ax) 
+     CALL wxios_add_vaxis("scatratio", SR_BINS, sratio_ax)
+     CALL wxios_add_vaxis("ReffIce", numMODISReffIceBins, reffICE_binCenters)
+     CALL wxios_add_vaxis("ReffLiq", numMODISReffLiqBins, reffLIQ_binCenters)
+     print*,'reffICE_binCenters=',reffICE_binCenters
+     CALL wxios_add_vaxis("tau", 7, ISCCP_TAU)
+
+  ENDIF
    
     zdtimemoy_cosp = freq_COSP         ! Frequence ou l on moyenne
@@ -363,10 +358,10 @@
 !                    nhoricosp(iff),cosp_nidfiles(iff)
 
-#ifdef CPP_XIOS
-        IF (.not. ok_all_xml) then
-         WRITE(lunout,*) 'wxios_add_file ',cosp_outfilenames(iff)
-         CALL wxios_add_file(cosp_outfilenames(iff),chfreq(iff),10)
-        ENDIF
-#endif
+         IF (using_xios) THEN
+           IF (.not. ok_all_xml) then
+             WRITE(lunout,*) 'wxios_add_file ',cosp_outfilenames(iff)
+             CALL wxios_add_file(cosp_outfilenames(iff),chfreq(iff),10)
+           ENDIF
+         ENDIF
 
 #ifndef CPP_IOIPSL_NO_OUTPUT 
